![Epesi Logo](/images/logo.png)
=
[![SourceForge](https://img.shields.io/sourceforge/dt/epesi.svg)](https://sourceforge.net/projects/epesi)

<b>EPESI BIM</b> (Business Information Manager) is a fully functional web CRM/ERP application to store, organize, access and share business records. Manage your data precisely, flexibly and easily, simplifying internal communication and making work-flow more efficient.

<b>About</b>

EPESI BIM is a result of many years of experience working with SMB businesses and addresses inefficiencies of current e-mail “collaboration” workflow and commonplace data management using inadequate spreadsheet applications. It is a completely web based application designed for small and medium-sized enterprises trying to optimize business processes, simplify office work and reduce administrative costs. It does not require any client to be installed - any modern browser on any operating system will work - drastically reducing the deployment cost.

Our software can make your organization more efficient, better organized and more competitive. We can help you simplify and automate internal procedures with management of important business information.

- To eliminate e-mail in our workplace we internally use <b>EPESI</b> for all tasks, notes, projects and tickets - making our life more organized. 
- In addition we use great multiplatform and programmable chat: <b>Telegram https://telegram.org/</b> available here at Github as well: https://github.com/telegramdesktop

Telegram is a messaging app with a focus on speed and security, it’s super-fast, simple and free. You can use Telegram on all your devices at the same time — your messages sync seamlessly across any number of your phones, tablets or computers.

- Epesi is already integrated with Telegram messaging platform te receive notifications from the <b>Watchdog</b> module (free and included with the latest release) as well as with Time tracking and reporting module integrated with Premium module Timesheets  http://epe.si/modules/premium/timesheets/

More information on epesi - description of functionality, demos and more visit: http://epe.si/free-crm/

<b>Support</b>
- For users - please visit our forum http://forum.epesibim.com/ - to receive free technical assistance
- For developers - please open issues here: https://github.com/Telaxus/EPESI/issues
- For Premium Support - paid service provided by Telaxus LLC - visit: http://telaxus.com/premium-support/

<b>Setup:</b>
- Online demo: http://demo.epesibim.com/
- Automatic - no technical expertise needed - setup hosting at epesi Cloud (free 30-day trial): http://epe.si/hosting
- Autoinstall via cPanel using Softaculous: https://www.softaculous.com/apps/erp/EPESI
</br>
 Video tutorial on how to install epesi using Softaculous autoinstaller via cPanel -  https://www.youtube.com/watch?v=FR4mQsHUNCY

<b>DIY - Do It Yourself manual methods:</b>
For experienced users and server administrators:
It requires properly configured HTTP server with PHP and MySQL or PostgreSQL database server - so called LAMP stack: https://en.wikipedia.org/wiki/LAMP_(software_bundle)

- Download from Sourceforge: http://sourceforge.net/projects/epesi
- Use Easy Install Script: http://sourceforge.net/projects/epesi/files/easy%20installer/
- Github: https://github.com/Telaxus/epesi

<b>Reviews</b>
- Users reviews collected from our support forum: http://epe.si/reviews/
- Sourceforge: https://sourceforge.net/projects/epesi/reviews/
- Review from September 19, 2016: "Top 10 Open Source CRM" by http://www.datamation.com/open-source/top-10-open-source-crm.html

<b>License:</b>

EPESI is released under the MIT License

Copyright © 2006-2016 Telaxus LLC

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/orsell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHERDEALINGS IN THE SOFTWARE.

<b>Credits:</b>

Telaxus LLC http://telaxus.com/

- Telaxus LLC is a technology company specializing in developoment of CRM and ERP solutions for small and medium size businesses utilizing our own platform - EPESI Business Information Manager.


<i>Copyright © 2006-2016 Telaxus LLC</i>

Enjoy,  
<b>EPESI Team</b>
